<html>
<head>
<title>OgreRenderSystemCapabilitiesSerializer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderSystemCapabilitiesSerializer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderSystemCapabilitiesSerializer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RenderSystemCapabilitiesSerializer_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RenderSystemCapabilitiesSerializer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystemCapabilities_8h.html">OgreRenderSystemCapabilities.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00048"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html" title="Class for serializing RenderSystemCapabilities to / from a .rendercaps script.">RenderSystemCapabilitiesSerializer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderSysAlloc</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050 
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00053"></a>00053         <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html" title="Class for serializing RenderSystemCapabilities to / from a .rendercaps script.">RenderSystemCapabilitiesSerializer</a>();
<a name="l00055"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a9788863dd6b6e5ab1062ec5c5eae582c">00055</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a9788863dd6b6e5ab1062ec5c5eae582c" title="default destructor">~RenderSystemCapabilitiesSerializer</a>() {}
<a name="l00056"></a>00056 
<a name="l00058"></a>00058         <span class="keywordtype">void</span> writeScript(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* caps, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> name, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> filename);
<a name="l00059"></a>00059         
<a name="l00061"></a>00061         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> writeString(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* caps, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> name);
<a name="l00062"></a>00062 
<a name="l00066"></a>00066         <span class="keywordtype">void</span> parseScript(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keyword">protected</span>:
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a8a2511af5b46c7d5421b8695c0aa17f2a9f60d9a011f3549653869444eb9540d9">00071</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a8a2511af5b46c7d5421b8695c0aa17f2">CapabilityKeywordType</a> {UNDEFINED_CAPABILITY_TYPE = 0, SET_STRING_METHOD, SET_INT_METHOD, SET_BOOL_METHOD, SET_REAL_METHOD,
<a name="l00072"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a8a2511af5b46c7d5421b8695c0aa17f2a8ffadaeacdbb345c326e0c9048c99b71">00072</a>                                 <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a8a2511af5b46c7d5421b8695c0aa17f2a8ffadaeacdbb345c326e0c9048c99b71">SET_CAPABILITY_ENUM_BOOL</a>, ADD_SHADER_PROFILE_STRING};
<a name="l00073"></a>00073         <span class="comment">// determines what keyword is what type of capability. For example:</span>
<a name="l00074"></a>00074         <span class="comment">// &quot;automipmap&quot; and &quot;pbuffer&quot; are both activated with setCapability (passing RSC_AUTOMIPMAP and RSC_PBUFFER respectivelly)</span>
<a name="l00075"></a>00075         <span class="comment">// while &quot;max_num_multi_render_targets&quot; is an integer and has it&#39;s own method: setMaxMultiNumRenderTargets</span>
<a name="l00076"></a>00076         <span class="comment">// we need to know these types to automatically parse each capability</span>
<a name="l00077"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a5e45bd28a99f3e2df888a8ffca2f07d6">00077</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, CapabilityKeywordType&gt;::type</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a5e45bd28a99f3e2df888a8ffca2f07d6">KeywordTypeMap</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#ade82d1788c31d4b627255993cc0d21e3">00078</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a5e45bd28a99f3e2df888a8ffca2f07d6">KeywordTypeMap</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#ade82d1788c31d4b627255993cc0d21e3">mKeywordTypeMap</a>;
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a83e8fc4085802944a14a697c4648166c">00080</a>         <span class="keyword">typedef</span> void (<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>::*SetStringMethod)(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;);
<a name="l00081"></a>00081         <span class="comment">// maps capability keywords to setCapability(String&amp; cap) style methods</span>
<a name="l00082"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a231b42ac522f855b66336f6aa9531ec1">00082</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, SetStringMethod&gt;::type</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a231b42ac522f855b66336f6aa9531ec1">SetStringMethodDispatchTable</a>;
<a name="l00083"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a196330e07020e83491d713ad3ae99994">00083</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a231b42ac522f855b66336f6aa9531ec1">SetStringMethodDispatchTable</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a196330e07020e83491d713ad3ae99994">mSetStringMethodDispatchTable</a>;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085         <span class="comment">// SET_INT_METHOD parsing tables</span>
<a name="l00086"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a5abfef8da51901b880864318a364a0e2">00086</a>         <span class="keyword">typedef</span> void (<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>::*SetIntMethod)(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>);
<a name="l00087"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a78cc33c7c0a5b9055a43cc60619c32c6">00087</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, SetIntMethod&gt;::type</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a78cc33c7c0a5b9055a43cc60619c32c6">SetIntMethodDispatchTable</a>;
<a name="l00088"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a03f00af0a19edfbc60402d7a8872227c">00088</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a78cc33c7c0a5b9055a43cc60619c32c6">SetIntMethodDispatchTable</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a03f00af0a19edfbc60402d7a8872227c">mSetIntMethodDispatchTable</a>;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090         <span class="comment">// SET_BOOL_METHOD parsing tables</span>
<a name="l00091"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#abaf393f4771e2ccea7bd384cc57bcbc1">00091</a>         <span class="keyword">typedef</span> void (<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>::*SetBoolMethod)(bool);
<a name="l00092"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a50f7aad6c0a8fab915a7ea71db6f07fa">00092</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, SetBoolMethod&gt;::type</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a50f7aad6c0a8fab915a7ea71db6f07fa">SetBoolMethodDispatchTable</a>;
<a name="l00093"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a6a31f76b92b1d5a9ca1dda68384d3c5a">00093</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a50f7aad6c0a8fab915a7ea71db6f07fa">SetBoolMethodDispatchTable</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a6a31f76b92b1d5a9ca1dda68384d3c5a">mSetBoolMethodDispatchTable</a>;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095         <span class="comment">// SET_REAL_METHOD parsing tables</span>
<a name="l00096"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#ab6da96bda957ce1c48bbd7d8f600af39">00096</a>         <span class="keyword">typedef</span> void (<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>::*SetRealMethod)(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>);
<a name="l00097"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#adee227ea058b37687e5a732e2e228842">00097</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, SetRealMethod&gt;::type</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#adee227ea058b37687e5a732e2e228842">SetRealMethodDispatchTable</a>;
<a name="l00098"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#af1f4f629bb96773a1a88f217f01d5218">00098</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#adee227ea058b37687e5a732e2e228842">SetRealMethodDispatchTable</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#af1f4f629bb96773a1a88f217f01d5218">mSetRealMethodDispatchTable</a>;
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a13744fda8b734ad0aadd5329bbf4ef29">00100</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, Capabilities&gt;::type</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a13744fda8b734ad0aadd5329bbf4ef29">CapabilitiesMap</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a86e25234daf7b0b6c3f87f22efc0e8fa">00101</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a13744fda8b734ad0aadd5329bbf4ef29">CapabilitiesMap</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a86e25234daf7b0b6c3f87f22efc0e8fa">mCapabilitiesMap</a>;
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a4e21eb61bea77d8506841724bca5e99b">00103</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> addCapabilitiesMapping(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> name, <a class="code" href="group__RenderSystem.html#ga3d2965b7f378ebdcfe8a4a6cf74c3de7" title="Enum describing the different hardware capabilities we want to check for OGRE_CAPS_VALUE(a, b) defines each capability.">Capabilities</a> cap)
<a name="l00104"></a>00104         {
<a name="l00105"></a>00105             mCapabilitiesMap.insert(CapabilitiesMap::value_type(name, cap));
<a name="l00106"></a>00106         }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109         <span class="comment">// capabilities lines for parsing are collected along with their line numbers for debugging</span>
<a name="l00110"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a6573e3f6a365cb40d20965153d098df0">00110</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;std::pair&lt;String, int&gt;</a> &gt;::type <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a6573e3f6a365cb40d20965153d098df0">CapabilitiesLinesList</a>;
<a name="l00111"></a>00111         <span class="comment">// the set of states that the parser can be in</span>
<a name="l00112"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a7f46b04783e30b6b2f4e184cff42c51e">00112</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a7f46b04783e30b6b2f4e184cff42c51e">ParseAction</a> {PARSE_HEADER, FIND_OPEN_BRACE, COLLECT_LINES};
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a541e70764d0a7977a2a5a5195f076e49">00114</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a541e70764d0a7977a2a5a5195f076e49">mCurrentLineNumber</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#ad37415c9d25efbb9a63dce1200682599">00115</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>* <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#ad37415c9d25efbb9a63dce1200682599">mCurrentLine</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#af464c040fc5cafa79f83ab6c816d31be">00116</a>         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#af464c040fc5cafa79f83ab6c816d31be">mCurrentStream</a>;
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#addc70bc605d63fc7a99f75809a01a0b9">00118</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#addc70bc605d63fc7a99f75809a01a0b9">mCurrentCapabilities</a>;
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#ae4ceb9939016072086704db8b0cfa164">00120</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> addKeywordType(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> keyword, <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a8a2511af5b46c7d5421b8695c0aa17f2">CapabilityKeywordType</a> type)
<a name="l00121"></a>00121         {
<a name="l00122"></a>00122             mKeywordTypeMap.insert(KeywordTypeMap::value_type(keyword, type));
<a name="l00123"></a>00123         }
<a name="l00124"></a>00124 
<a name="l00125"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#afa5a003f39ee273db81283afab20c2d1">00125</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a8a2511af5b46c7d5421b8695c0aa17f2">CapabilityKeywordType</a> getKeywordType(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; keyword)<span class="keyword"> const</span>
<a name="l00126"></a>00126 <span class="keyword">        </span>{
<a name="l00127"></a>00127                         KeywordTypeMap::const_iterator it = mKeywordTypeMap.find(keyword);
<a name="l00128"></a>00128             <span class="keywordflow">if</span>(it != mKeywordTypeMap.end())
<a name="l00129"></a>00129                              <span class="keywordflow">return</span> (*it).second;
<a name="l00130"></a>00130                         <span class="keywordflow">else</span>
<a name="l00131"></a>00131                         {
<a name="l00132"></a>00132                              logParseError(<span class="stringliteral">&quot;Can&#39;t find the type for keyword: &quot;</span> + keyword);
<a name="l00133"></a>00133                              <span class="keywordflow">return</span> UNDEFINED_CAPABILITY_TYPE;
<a name="l00134"></a>00134                         }
<a name="l00135"></a>00135         }
<a name="l00136"></a>00136 
<a name="l00137"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#aea5fba8755a99959ba638111b799aeda">00137</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> addSetStringMethod(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> keyword, SetStringMethod method)
<a name="l00138"></a>00138         {
<a name="l00139"></a>00139             mSetStringMethodDispatchTable.insert(SetStringMethodDispatchTable::value_type(keyword, method));
<a name="l00140"></a>00140         }
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#aa5eaa1485030541696b5705b8d6fb5cb">00142</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> callSetStringMethod(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; keyword, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val)
<a name="l00143"></a>00143         {
<a name="l00144"></a>00144             SetStringMethodDispatchTable::iterator methodIter = mSetStringMethodDispatchTable.find(keyword);
<a name="l00145"></a>00145             <span class="keywordflow">if</span> (methodIter != mSetStringMethodDispatchTable.end())
<a name="l00146"></a>00146             {
<a name="l00147"></a>00147                             SetStringMethod m = (*methodIter).second;
<a name="l00148"></a>00148                 (mCurrentCapabilities-&gt;*m)(val);
<a name="l00149"></a>00149             }
<a name="l00150"></a>00150             <span class="keywordflow">else</span>
<a name="l00151"></a>00151             {
<a name="l00152"></a>00152                 logParseError(<span class="stringliteral">&quot;undefined keyword: &quot;</span> + keyword);
<a name="l00153"></a>00153             }
<a name="l00154"></a>00154         }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#aa13f3e5865c384dd17d29f912e5d45c4">00157</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> addSetIntMethod(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> keyword, SetIntMethod method)
<a name="l00158"></a>00158         {
<a name="l00159"></a>00159             mSetIntMethodDispatchTable.insert(SetIntMethodDispatchTable::value_type(keyword, method));
<a name="l00160"></a>00160         }
<a name="l00161"></a>00161 
<a name="l00162"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a3733282515d5e9a2d9c72ef618a1894b">00162</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> callSetIntMethod(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; keyword, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> val)
<a name="l00163"></a>00163         {
<a name="l00164"></a>00164             SetIntMethodDispatchTable::iterator methodIter = mSetIntMethodDispatchTable.find(keyword);
<a name="l00165"></a>00165             <span class="keywordflow">if</span> (methodIter != mSetIntMethodDispatchTable.end())
<a name="l00166"></a>00166             {
<a name="l00167"></a>00167                             SetIntMethod m = (*methodIter).second;
<a name="l00168"></a>00168                 (mCurrentCapabilities-&gt;*m)(val);
<a name="l00169"></a>00169             }
<a name="l00170"></a>00170             <span class="keywordflow">else</span>
<a name="l00171"></a>00171             {
<a name="l00172"></a>00172                 logParseError(<span class="stringliteral">&quot;undefined keyword: &quot;</span> + keyword);
<a name="l00173"></a>00173             }  
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a86281fc98154f037c88796cc618fec74">00177</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> addSetBoolMethod(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> keyword, SetBoolMethod method)
<a name="l00178"></a>00178         {
<a name="l00179"></a>00179             mSetBoolMethodDispatchTable.insert(SetBoolMethodDispatchTable::value_type(keyword, method));
<a name="l00180"></a>00180         }
<a name="l00181"></a>00181 
<a name="l00182"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#ae146f62425251de56c57b9d5d9e93afd">00182</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> callSetBoolMethod(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; keyword, <span class="keywordtype">bool</span> val)
<a name="l00183"></a>00183         {
<a name="l00184"></a>00184             SetBoolMethodDispatchTable::iterator methodIter = mSetBoolMethodDispatchTable.find(keyword);
<a name="l00185"></a>00185             <span class="keywordflow">if</span> (methodIter != mSetBoolMethodDispatchTable.end())
<a name="l00186"></a>00186             {
<a name="l00187"></a>00187                             SetBoolMethod m = (*methodIter).second;
<a name="l00188"></a>00188                 (mCurrentCapabilities-&gt;*m)(val);
<a name="l00189"></a>00189             }
<a name="l00190"></a>00190             <span class="keywordflow">else</span>
<a name="l00191"></a>00191             {
<a name="l00192"></a>00192                 logParseError(<span class="stringliteral">&quot;undefined keyword: &quot;</span> + keyword);
<a name="l00193"></a>00193                         }
<a name="l00194"></a>00194         }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a1d4e29e084aafed0900b7c33df460158">00197</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> addSetRealMethod(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> keyword, SetRealMethod method)
<a name="l00198"></a>00198         {
<a name="l00199"></a>00199             mSetRealMethodDispatchTable.insert(SetRealMethodDispatchTable::value_type(keyword, method));
<a name="l00200"></a>00200         }
<a name="l00201"></a>00201 
<a name="l00202"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a11fd7fb5f88539cf23fcedb8c905e094">00202</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> callSetRealMethod(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; keyword, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> val)
<a name="l00203"></a>00203         {
<a name="l00204"></a>00204             SetRealMethodDispatchTable::iterator methodIter = mSetRealMethodDispatchTable.find(keyword);
<a name="l00205"></a>00205             <span class="keywordflow">if</span> (methodIter != mSetRealMethodDispatchTable.end())
<a name="l00206"></a>00206             {
<a name="l00207"></a>00207                             SetRealMethod m = (*methodIter).second;
<a name="l00208"></a>00208                 (mCurrentCapabilities-&gt;*m)(val);
<a name="l00209"></a>00209             }
<a name="l00210"></a>00210             <span class="keywordflow">else</span>
<a name="l00211"></a>00211             {
<a name="l00212"></a>00212                 logParseError(<span class="stringliteral">&quot;undefined keyword: &quot;</span> + keyword);
<a name="l00213"></a>00213                         }
<a name="l00214"></a>00214         }
<a name="l00215"></a>00215 
<a name="l00216"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#a587f8519a3187593d169407cc4ca80c4">00216</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> addShaderProfile(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val)
<a name="l00217"></a>00217         {
<a name="l00218"></a>00218             mCurrentCapabilities-&gt;addShaderProfile(val);
<a name="l00219"></a>00219         }
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html#ab904911f7a8976cf3fb16338281e74af">00221</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> setCapabilityEnumBool(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">bool</span> val)
<a name="l00222"></a>00222         {
<a name="l00223"></a>00223             <span class="comment">// check for errors</span>
<a name="l00224"></a>00224             <span class="keywordflow">if</span>(mCapabilitiesMap.find(name) == mCapabilitiesMap.end())
<a name="l00225"></a>00225             {
<a name="l00226"></a>00226                 logParseError(<span class="stringliteral">&quot;Undefined capability: &quot;</span> + name);
<a name="l00227"></a>00227                 <span class="keywordflow">return</span>;
<a name="l00228"></a>00228             }
<a name="l00229"></a>00229             <span class="comment">// only set true capabilities, we can&#39;t unset false</span>
<a name="l00230"></a>00230             <span class="keywordflow">if</span>(val)
<a name="l00231"></a>00231             {
<a name="l00232"></a>00232                 <a class="code" href="group__RenderSystem.html#ga3d2965b7f378ebdcfe8a4a6cf74c3de7" title="Enum describing the different hardware capabilities we want to check for OGRE_CAPS_VALUE(a, b) defines each capability.">Capabilities</a> cap = mCapabilitiesMap[name];
<a name="l00233"></a>00233                 mCurrentCapabilities-&gt;setCapability(cap);
<a name="l00234"></a>00234             }
<a name="l00235"></a>00235         }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237         <span class="keywordtype">void</span> initialiaseDispatchTables();
<a name="l00238"></a>00238 
<a name="l00239"></a>00239         <span class="keywordtype">void</span> parseCapabilitiesLines(CapabilitiesLinesList&amp; linesList);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241         <span class="keywordtype">void</span> logParseError(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; error) <span class="keyword">const</span>;
<a name="l00242"></a>00242 
<a name="l00243"></a>00243     };
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
